#most of these tasks are to help ansible connect to the host as a further check
- name: ensure known_hosts file is clean of prior entries
  shell: "{{ item }}"
  delegate_to: "{{ var_controlhost }}" 
  with_items:
    - "ssh-keygen -R {{ found_ipv4.stdout }}"
    - "ssh-keygen -R {{ var_vm_name }}"
- name: ensure ssh is available
  ansible.builtin.wait_for: 
    port: 22 
    host: "{{ var_vm_name }}" 
    search_regex: 'OpenSSH' 
    delay: 3 
    timeout: 60
  delegate_to: "{{ var_controlhost }}" 
- name: keyscan the new host by IP
  shell: "ssh-keyscan -4 -t ed25519 {{ found_ipv4.stdout }} | grep 'ssh-ed25519'"
  register: host_key_ip
  delegate_to: "{{ var_controlhost }}" 
- name: keyscan the new host by name
  shell: "ssh-keyscan -4 -t ed25519  {{ var_vm_name }} | grep 'ssh-ed25519'"
  register: host_key
  delegate_to: "{{ var_controlhost }}" 
- name: ensure host keys in known_hosts
  shell: "{{ item }}"
  delegate_to: "{{ var_controlhost }}" 
  with_items:
    - "echo {{ host_key_ip.stdout }} >> $HOME/.ssh/known_hosts"
    - "echo {{ host_key.stdout }} >> $HOME/.ssh/known_hosts"

- name: get key by IP
  shell: "cat $HOME/.ssh/known_hosts | grep '{{ found_ipv4.stdout }}'"
  register: known_hosts_ip
  delegate_to: "{{ var_controlhost }}" 
- name: get key by hostname
  shell: "cat $HOME/.ssh/known_hosts | grep '{{ var_vm_name }}'"
  register: known_hosts
  delegate_to: "{{ var_controlhost }}" 
- name: output search results of known hosts (debug)
  debug:
    msg:
      - "{{ known_hosts_ip.stdout }}"
      - "{{ known_hosts.stdout }}"
  changed_when: false
 
